function  likelihood = gaussian_measurement_model(pf, predictParticles, measurement, input_stdevs) %#ok<INUSL>
%exampleHelperCarBotMeasurementLikelihood Compute the likelihood for each predicted
%   particles, which will later be used to compute importance weight. 

%   Copyright 2015-2016 The MathWorks, Inc.

    % The measurement contains all state variables
    predictMeasurement = predictParticles;
    
    
    stdev_inv_elts = [1/input_stdevs(1) 1/input_stdevs(2) 1/input_stdevs(3) 1/input_stdevs(4)];
    stdev_inv_elts_rep = ones(1,size(predictParticles, 1))' * stdev_inv_elts;

    % Calculate observed error between predicted and actual measurement
    % NOTE in this example, we don't have full state observation, but only
    % the measurement of current pose, therefore the measurementErrorNorm
    % is only based on the pose error.
    measurementError = bsxfun(@minus, predictMeasurement(:,1:4), measurement);
    %measurementErrorNorm = measurementError * diag(cov_inv_elts) * measurementError';
    measurementErrorNorm = sum((measurementError .* stdev_inv_elts_rep).^2, 2);

    % Normal-distributed noise of measurement
    % Assuming measurements on all three pose components have the same error distribution 
    
    % Convert error norms into likelihood measure. 
    % Evaluate the PDF of the multivariate normal distribution 
    meas_likelihood = 1/sqrt((2*pi).^4 * prod(input_stdevs.^2)) * exp(-0.5 * measurementErrorNorm);
    
    sample_mean = mean(predictParticles,1);
    sample_stdev_inv = 1 ./ std(predictParticles,0, 1);
    sample_stdev_inv_rep = ones(1,size(predictParticles, 1))' * sample_stdev_inv;
    TransitionError = bsxfun(@minus, predictMeasurement(:,1:4), sample_mean);
    TransitionErrorNorm = sum((TransitionError .* sample_stdev_inv_rep).^2, 2);
    trans_likelihood = 1/sqrt((2*pi).^4 * prod(sample_stdev_inv.^2)) * exp(-0.5 * TransitionErrorNorm);
    
    likelihood = trans_likelihood .* meas_likelihood;
    
    
    %maybe we need to multiply by the p with the sample mean and stdev?
    
end
