big = 1;
if(big == 1)
    fileID_noise = fopen('short_path_noisy_10_1.txt','r');
    fileID_true = fopen('short_path_true.txt','r');
    formatSpec = '%f %f %f %f %f';
    sizeA = [5 Inf];
    noisy_measurements = fscanf(fileID_noise,formatSpec,sizeA);
    true_measurements = fscanf(fileID_true,formatSpec,sizeA);
    dt = noisy_measurements(1,2);
    noisy_measurements = noisy_measurements(2:end,:);
    true_measurements = true_measurements(2:end,:);
    measurement_stdev = zeros(1, 4);
    measurement_stdev(1) = 10;
    measurement_stdev(2) = 10;
    measurement_stdev(3) = 1;
    measurement_stdev(4) = 1;
    
    init_stdev(1) = 20;
    init_stdev(2) = 20;
    init_stdev(3) = 5;
    init_stdev(4) = 5;
    
    transition_stdev(1) = 10;
    transition_stdev(2) = 10;
    transition_stdev(3) = 1;
    transition_stdev(4) = 1;
    
else
    load data.mat
    noisy_measurements = noisy;
    true_measurements = true;
    dt = 1;    
end 

numParticles = 500;
pf = robotics.ParticleFilter;

initialize(pf, numParticles, [noisy_measurements(:,1)'], diag(init_stdev));
pf.StateEstimationMethod = 'mean';
pf.ResamplingMethod = 'systematic';

% StateTransitionFcn defines how particles evolve without measurement
pf.StateTransitionFcn = @first_order_transition_function;

% MeasurementLikelihoodFcn defines how measurement affect the our estimation
pf.MeasurementLikelihoodFcn = @gaussian_measurement_model;

% Last best estimation for x, y and theta
lastBestGuess = [0 0 0];

simulationTime = 0; 

predicted_states = zeros(size(noisy_measurements));

for i = 2 : size(noisy_measurements, 2)

    % Generate motion command that is to be sent to the robot
    % NOTE there will be some discrepancy between the commanded motion and the
    % motion actually executed by the robot. 
%     uCmd(1) = 0.7*abs(sin(simulationTime)) + 0.1;  % linear velocity
%     uCmd(2) = 0.08*cos(simulationTime);            % angular velocity
%     
%     drive(carbot, uCmd);
%         
    % Predict the carbot pose based on the motion model
    [statePred, covPred] = predict(pf, dt, transition_stdev);
    %[statePred, covPred] = predict(pf, dt, uCmd);

    % Get GPS reading
    measurement = noisy_measurements(:,i);
    %measurement = exampleHelperCarBotGetGPSReading(carbot);

    % If measurement is available, then call correct, otherwise just use
    % predicted result
    if ~isempty(measurement)
        [stateCorrected, covCorrected] = correct(pf, measurement', measurement_stdev);
    else
        stateCorrected = statePred;
        covCorrected = covPred;
    end

    [State, StateCovariance] = getStateEstimate(pf);
    lastBestGuess = State(1:4);
    predicted_states(:,i) = lastBestGuess;
%     scatter(true_measurements(1,i), true_measurements(2,i));
%     hold on
%     scatter(noisy_measurements(1,i), noisy_measurements(2,i));
%     hold on
%     scatter(statePred(1), statePred(2))
%     hold on
%     scatter(stateCorrected(1), stateCorrected(2))
%     hold on
%     legend('True', 'Noisy','Predicted','Corrected')
    
    % Update simulation time
%    exampleHelperCarBotStateTransition
    simulationTime = simulationTime + dt;
end

N = size(predicted_states,2);
scatter(predicted_states(1,1:N), predicted_states(2,1:N))
hold on
scatter(noisy_measurements(1,1:N), noisy_measurements(2,1:N))
hold on
scatter(true_measurements(1,1:N), true_measurements(2,1:N))
legend('Predicted', 'Noisy', 'True')

x_MSE_before = sum((noisy_measurements(1,2:N) - true_measurements(1,2:N)).^2) / (size(true_measurements, 2) - 1);
x_MSE_after = sum((predicted_states(1,2:N) - true_measurements(1,2:N)).^2) / (size(true_measurements, 2) - 1);

y_MSE_before = sum((noisy_measurements(2,2:N) - true_measurements(2,2:N)).^2) / (size(true_measurements, 2) - 1);
y_MSE_after = sum((predicted_states(2,2:N) - true_measurements(2,2:N)).^2) / (size(true_measurements, 2) - 1);

x_vel_MSE_before = sum((noisy_measurements(3,2:N) - true_measurements(3,2:N)).^2) / (size(true_measurements, 2) - 1);
x_vel_MSE_after = sum((predicted_states(3,2:N) - true_measurements(3,2:N)).^2) / (size(true_measurements, 2) - 1);

y_vel_MSE_before = sum((noisy_measurements(4,2:N) - true_measurements(4,2:N)).^2) / (size(true_measurements, 2) - 1);
y_vel_MSE_after = sum((predicted_states(4,2:N) - true_measurements(4,2:N)).^2) / (size(true_measurements, 2) - 1);
