#ifndef Particle_hpp
#define Particle_hpp

#include <stdio.h>
#include <iostream>
#include <fstream>
#include <time.h>       /* time */
#include <random>
#include <vector>
#include <chrono>

class Observation{
protected:
public:
    std::vector<double> state;
    Observation();
    Observation(int dimension);
    Observation(double * state_, int dimension_);
    Observation(std::vector<double> & state_);
    Observation(const Observation &ops2);
    
    void set_state_value(double new_val, int index);
    double get_state_value(int index);
    
    void set_state(std::vector<double> & state_);
    void increment_state_value(double value, int index);
    void get_state(std::vector<double> & state_); //get state by reference
    std::vector<double> get_state_copy();

    int dimension = 4;
    
    void operator+=(const Observation & p);
    void operator/=(const double & denominator);
    
};

class Particle: public Observation{
    double weight;
public:
    Particle();
    Particle(int size);
    Particle(std::vector<double> & state_, double weight_);
    Particle(const Particle &p2);
    void set_weight(double new_weight);
    double get_weight();
    
};

//misc functions vaguely related to Particles
Observation operator + (const Observation& op1, const Observation& op2);
Observation operator - (const Observation& op1, const Observation& op2);
Observation squared_difference(const std::vector<double>& op1, const std::vector<double>& op2);
void load_true_states(std::vector<Observation> & true_states, std::string filename);

#endif /* Particle_hpp */
